package org.silverpeas.mobile.shared.services.rest;

import static org.fusesource.restygwt.client.AbstractJsonEncoderDecoder.*;

public class ServiceNews_Generated_RestServiceProxy_ implements org.silverpeas.mobile.shared.services.rest.ServiceNews, org.fusesource.restygwt.client.RestServiceProxy {
  private org.fusesource.restygwt.client.Resource resource = null;
  
  public void setResource(org.fusesource.restygwt.client.Resource resource) {
    this.resource = resource;
  }
  public org.fusesource.restygwt.client.Resource getResource() {
    if (this.resource == null) {
      String serviceRoot = org.fusesource.restygwt.client.Defaults.getServiceRoot();
      this.resource = new org.fusesource.restygwt.client.Resource(serviceRoot).resolve("/mobile/news");
    }
    return this.resource;
  }
  private org.fusesource.restygwt.client.Dispatcher dispatcher = null;
  
  public void setDispatcher(org.fusesource.restygwt.client.Dispatcher dispatcher) {
    this.dispatcher = dispatcher;
  }
  
  public org.fusesource.restygwt.client.Dispatcher getDispatcher() {
    return this.dispatcher;
  }
  public void createNews(java.lang.String appId, org.silverpeas.mobile.shared.dto.news.NewsDTO news, org.fusesource.restygwt.client.MethodCallback<org.silverpeas.mobile.shared.dto.news.NewsDTO> callback) {
    final java.lang.String final_appId = appId;
    final org.silverpeas.mobile.shared.dto.news.NewsDTO final_news = news;
    final org.fusesource.restygwt.client.Method __method =
    getResource()
    .resolve(""+(appId== null? null : com.google.gwt.http.client.URL.encodePathSegment(appId))+"/create")
    .post();
    __method.setDispatcher(this.dispatcher);
    __method.header(org.fusesource.restygwt.client.Resource.HEADER_ACCEPT, org.fusesource.restygwt.client.Resource.CONTENT_TYPE_JSON);
    __method.header(org.fusesource.restygwt.client.Resource.HEADER_CONTENT_TYPE, "application/json");
    __method.json(org.silverpeas.mobile.shared.dto.news.NewsDTO_Generated_JsonEncoderDecoder_.INSTANCE.encode(news));
    try {
      __method.send(new org.fusesource.restygwt.client.AbstractRequestCallback<org.silverpeas.mobile.shared.dto.news.NewsDTO>(__method, callback) {
        protected org.silverpeas.mobile.shared.dto.news.NewsDTO parseResult() throws Exception {
          try {
            return org.silverpeas.mobile.shared.dto.news.NewsDTO_Generated_JsonEncoderDecoder_.INSTANCE.decode(com.google.gwt.json.client.JSONParser.parse(__method.getResponse().getText()));
          } catch (Throwable __e) {
            throw new org.fusesource.restygwt.client.ResponseFormatException("Response was NOT a valid JSON document", __e);
          }
        }
      });
    } catch (com.google.gwt.http.client.RequestException __e) {
      callback.onFailure(__method,__e);
    }
  }
  public void getNews(java.lang.String appId, org.fusesource.restygwt.client.MethodCallback<java.util.List<org.silverpeas.mobile.shared.dto.news.NewsDTO>> callback) {
    final java.lang.String final_appId = appId;
    final org.fusesource.restygwt.client.Method __method =
    getResource()
    .resolve(""+(appId== null? null : com.google.gwt.http.client.URL.encodePathSegment(appId))+"/all")
    .get();
    __method.setDispatcher(this.dispatcher);
    __method.header(org.fusesource.restygwt.client.Resource.HEADER_ACCEPT, org.fusesource.restygwt.client.Resource.CONTENT_TYPE_JSON);
    try {
      __method.send(new org.fusesource.restygwt.client.AbstractRequestCallback<java.util.List<org.silverpeas.mobile.shared.dto.news.NewsDTO>>(__method, callback) {
        protected java.util.List<org.silverpeas.mobile.shared.dto.news.NewsDTO> parseResult() throws Exception {
          try {
            return toList(com.google.gwt.json.client.JSONParser.parse(__method.getResponse().getText()), org.silverpeas.mobile.shared.dto.news.NewsDTO_Generated_JsonEncoderDecoder_.INSTANCE);
          } catch (Throwable __e) {
            throw new org.fusesource.restygwt.client.ResponseFormatException("Response was NOT a valid JSON document", __e);
          }
        }
      });
    } catch (com.google.gwt.http.client.RequestException __e) {
      callback.onFailure(__method,__e);
    }
  }
  public void getNewsByPubId(java.lang.String appId, java.lang.String pubId, org.fusesource.restygwt.client.MethodCallback<org.silverpeas.mobile.shared.dto.news.NewsDTO> callback) {
    final java.lang.String final_appId = appId;
    final java.lang.String final_pubId = pubId;
    final org.fusesource.restygwt.client.Method __method =
    getResource()
    .resolve(""+(appId== null? null : com.google.gwt.http.client.URL.encodePathSegment(appId))+"/byPubId/"+(pubId== null? null : com.google.gwt.http.client.URL.encodePathSegment(pubId))+"")
    .get();
    __method.setDispatcher(this.dispatcher);
    __method.header(org.fusesource.restygwt.client.Resource.HEADER_ACCEPT, "application/json");
    try {
      __method.send(new org.fusesource.restygwt.client.AbstractRequestCallback<org.silverpeas.mobile.shared.dto.news.NewsDTO>(__method, callback) {
        protected org.silverpeas.mobile.shared.dto.news.NewsDTO parseResult() throws Exception {
          try {
            return org.silverpeas.mobile.shared.dto.news.NewsDTO_Generated_JsonEncoderDecoder_.INSTANCE.decode(com.google.gwt.json.client.JSONParser.parse(__method.getResponse().getText()));
          } catch (Throwable __e) {
            throw new org.fusesource.restygwt.client.ResponseFormatException("Response was NOT a valid JSON document", __e);
          }
        }
      });
    } catch (com.google.gwt.http.client.RequestException __e) {
      callback.onFailure(__method,__e);
    }
  }
  public void updateNews(java.lang.String appId, org.silverpeas.mobile.shared.dto.news.NewsDTO news, org.fusesource.restygwt.client.MethodCallback<java.lang.Void> callback) {
    final java.lang.String final_appId = appId;
    final org.silverpeas.mobile.shared.dto.news.NewsDTO final_news = news;
    final org.fusesource.restygwt.client.Method __method =
    getResource()
    .resolve(""+(appId== null? null : com.google.gwt.http.client.URL.encodePathSegment(appId))+"/update")
    .put();
    __method.setDispatcher(this.dispatcher);
    __method.header(org.fusesource.restygwt.client.Resource.HEADER_ACCEPT, org.fusesource.restygwt.client.Resource.CONTENT_TYPE_JSON);
    __method.header(org.fusesource.restygwt.client.Resource.HEADER_CONTENT_TYPE, "application/json");
    __method.json(org.silverpeas.mobile.shared.dto.news.NewsDTO_Generated_JsonEncoderDecoder_.INSTANCE.encode(news));
    try {
      __method.send(new org.fusesource.restygwt.client.AbstractRequestCallback<java.lang.Void>(__method, callback) {
        protected java.lang.Void parseResult() throws Exception {
          return (java.lang.Void) null;
        }
      });
    } catch (com.google.gwt.http.client.RequestException __e) {
      callback.onFailure(__method,__e);
    }
  }
}
